#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR DATA FILES  

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use psfp;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "domailing") { &domailing; }
if ($q->param('fct') eq "do_send") { &do_send; }



##################################################################################


sub do_send
{

$st = $q->param('st');
if ($st eq "") { $st = 0; }

$emailnr = $q->param('emailnr');
$subscribed_only = $q->param('subscribed_only');


### SET UP SEND

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

if ($subscribed_only eq "Y") { $wsql = " WHERE subscribed = 'Y' "; }

$sql = "SELECT * FROM lnkusers $wsql ORDER BY rgsname LIMIT $st, $emailnr";
#print "--> $sql <BR>";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}



### GET EMAIL MSG

$emailmsg = acs::get_file_contents("$data_dir/tmp/users.eml");
@emlines = split(/\n/, $emailmsg);

$from_email = $emlines[0];
$from_name = $emlines[1];
$subject = $emlines[2];

$rc = 0;
foreach $item (@emlines)
	{
	if ($rc > 2)
		{
		$email_message = $email_message . $item . "\n";
		}
		$rc++;
	}


#### SEND MAILS

	while ( @row = $sth->fetchrow() )
		{
		$tmpmsg = $email_message;

		$tmpmsg =~ s/%%username%%/$row[1]/i;
		$tmpmsg =~ s/%%password%%/$row[2]/i;
		$tmpmsg =~ s/%%name%%/$row[3]/i;
		$tmpmsg =~ s/%%extrafield1%%/$row[5]/i;
		$tmpmsg =~ s/%%extrafield2%%/$row[6]/i;
		$tmpmsg =~ s/%%extrafield3%%/$row[7]/i;
		$tmpmsg =~ s/%%extrafield4%%/$row[8]/i;
		$tmpmsg =~ s/%%extrafield5%%/$row[9]/i;
		$tmpmsg =~ s/%%extrafield6%%/$row[10]/i;
		$tmpmsg =~ s/%%extrafield7%%/$row[11]/i;
		$tmpmsg =~ s/%%extrafield8%%/$row[12]/i;
		$tmpmsg =~ s/%%extrafield9%%/$row[13]/i;
		$tmpmsg =~ s/%%extrafield10%%/$row[14]/i;


		### SEND EMAIL
		acs::send_email ($from_name, $from_email, $row[4], $subject, $tmpmsg);

		#print "-->$row[1]<BR>";
		
		$found_row = "true";
		
		$currsend = $currsend . "$row[3] - $row[4]<BR>";
		}

$sth->finish;
$dbh->disconnect;


$st = $st + $emailnr;




#### IF FINISHED
if ($found_row ne "true")
	{
	
	$hbox1 = acs::get_heading_box("$web_url/ic_users.gif", "Send Complete", qq[
You may <a href="javascript:onClick=window.close()">close</a> this window or <a
    href="$admin_url/admin63.cgi">click here to continue</a>
	]);


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">  
</head>
<body>

$hbox1

</body>
</html>
];

exit;
	
	}


### GET PERCENTBAR

$oldst = $st - $emailnr;

$total = $q->param('total');
$perc = ($oldst / $total) * 100;
$perc = sprintf("%5.2f",$perc);
$barwidth = $perc . "%";


$hbox1 = acs::get_heading_box("$web_url/ic_users.gif", "<b>Sending Mail To:</b> ", qq[
 $currsend
]);


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">  
<meta HTTP-EQUIV="REFRESH" CONTENT="2;URL=$admin_url/admin63.cgi?fct=do_send&emailnr=$emailnr&st=$st&subscribed_only=$subscribed_only&total=$total">
</head>
<body>


<table border="0" cellpadding="5" cellspacing="0" width="100%"
style="border: 1px solid rgb(221,221,221)">
  <tr>
    <td width="12%"><strong><font face="Verdana" size="1"><img src="$web_url/working.gif"></font></strong></td>
    <td width="12%"><p align="center"><strong>$perc% Complete</strong></td>
    <td width="88%"><table border="0" cellpadding="0" cellspacing="0" width="$perc%">
      <tr>
        <td width="100%" height="30" background="$web_url/bar.gif"></td>
      </tr>
    </table>
    </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>

$hbox1


</body>
</html>
];

}






sub domailing
{

### CHECK FOR ERRORS

$from_email = $q->param('from_email');
$from_name = $q->param('from_name');
$subject = $q->param('subject');
$message = $q->param('message');
$emailnr = $q->param('emailnr');
$subscribed_only = $q->param('subscribed_only');
$test_email = $q->param('test_email');
$prevent_dupl = $q->param('prevent_dupl');
$include_prem = $q->param('include_prem');

if ($from_email eq "")  { acs::problem_popup("You have to provide an email address where the email is being sent from."); exit;}
if ($from_name eq "")  { acs::problem_popup("You have to provide a name from who the email is being sent."); exit;}
if ($subject eq "")  { acs::problem_popup("You have to provide a subject for the email message."); exit;}
if ($message eq "")  { acs::problem_popup("You have to provide a message for the email message."); exit;}



#### SEND TEST EMAIL IF CHOSEN TO SEND TEST EMAIL
if ($q->param('testbut') eq "   Send Test Email    ") { &send_test_email; }

if ($emailnr < 1) { acs::problem_popup("You have to provide a number of how many messages will be sent at a time."); exit;}


#### CREATE TEMP DIR WHERE WE WILL STORE TEMP DATA
$temp_dir = "$data_dir/tmp";
if ((-e $temp_dir) < 1) {
mkdir ($temp_dir, $default_permissions);
chmod($default_permissions,"$upload_dir","$upload_dir"); }


### RECORD EMAIL MSG THAT WE WANT TO SEND
open (EML, "> $data_dir/tmp/users.eml");
	print EML $from_email . "\n";
	print EML $from_name . "\n";
	print EML $subject . "\n";
	print EML $message . "\n";
close (EML);


#### COUNT HOW MANY EMAILS WE ARE GOING TO SEND FOR PERCENTAGE BAR

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

if ($subscribed_only eq "Y") { $wsql = " WHERE (subscribed = 'Y') "; }
#if ($prevent_dupl eq "Y") { $groupsql = " GROUP BY email"; }
#if ($include_prem ne "") 
#		{
#		$now = time();
#		$exclude_prem = " AND (subs_expire < '$now') AND (premium > '0')"; 
#		}
		

$sql = "SELECT COUNT(*) FROM lnkusers $wsql ORDER BY rgsname";
#print "--> $sql <BR><BR>";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

	while ( @row = $sth->fetchrow() )
		{
		$total = $row[0];
		}

$sth->finish;
$dbh->disconnect;




$hbox1 = acs::get_heading_box("$web_url/ic_users.gif", "Working... Please Wait... ", qq[
Preparing to send email.
]);


print qq[
<html>

<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="2;URL=$admin_url/admin63.cgi?fct=do_send&amp;emailnr=$emailnr&amp;subscribed_only=$subscribed_only&amp;total=$total">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">  
</head>

<body>

<table border="0" cellpadding="5" cellspacing="0" width="100%"
style="border: 1px solid rgb(221,221,221)">
  <tr>
    <td width="112%"><font face="Verdana" size="1"><strong><img src="$web_url/working.gif"></strong></font></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>


$hbox1

</body>
</html>
];



}




sub send_test_email
{

if ($test_email eq "")  { acs::problem_popup("You have to provide a an email address where the test email will be sent to."); exit;}

$message2 = $message;

$message =~ s/%%username%%/SomeUserName/i;
$message =~ s/%%password%%/SomePassword/i;
$message =~ s/%%name%%/John Doe/i;
$message =~ s/%%extrafield1%%/Extra Field Data 1/i;
$message =~ s/%%extrafield2%%/Extra Field Data 2/i;
$message =~ s/%%extrafield3%%/Extra Field Data 3/i;
$message =~ s/%%extrafield4%%/Extra Field Data 4/i;
$message =~ s/%%extrafield5%%/Extra Field Data 5/i;
$message =~ s/%%extrafield6%%/Extra Field Data 6/i;
$message =~ s/%%extrafield7%%/Extra Field Data 7/i;
$message =~ s/%%extrafield8%%/Extra Field Data 8/i;
$message =~ s/%%extrafield9%%/Extra Field Data 9/i;
$message =~ s/%%extrafield10%%/Extra Field Data 10/i;

acs::send_email ($from_name, $from_email, $test_email, $subject, $message);


$hbox1 = acs::get_heading_box("$web_url/ic_users.gif", "Test Email Sent ", qq[
<form method="POST" action="$admin_url/admin63.cgi">
      <input type="hidden" name="from_email1" value="$from_email"><input type="hidden"
      name="from_name1" value="$from_name"><input type="hidden" name="subject1" value="$subject"><input
      type="hidden" name="message1" value="$message2"><input type="hidden" name="emailnr1"
      value="$emailnr"><input type="hidden" name="subscribed_only1" value="$subscribed_only"><p><input
      type="submit" value="Click here to continue" name="B1"> </p>
    </form>
]);



print qq[
<html>
<head>
<title>PowerSeek Mailer</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">  
</head>
<body>

$hbox1

</body>
</html>
];

exit;

}







sub start
{


$from_email1 = $q->param('from_email1');
$from_name1 = $q->param('from_name1');
$subject1 = $q->param('subject1');
$message1 = $q->param('message1');
$emailnr1 = $q->param('emailnr1'); if ($emailnr1 eq "") { $emailnr1 = 10; }

$subscribed_only1 = $q->param('subscribed_only1');
if ($subscribed_only1 eq "Y")
	{
	$subschecked = "checked";
	}


$hbox1 = acs::get_heading_box("$web_url/ic_users.gif", "Send Email to Users ", qq[

    <a href="$admin_url/admin33.cgi"
    onclick="popup('$admin_url/admin33.cgi',750,600);return false;">Email Mailing &amp;
    Address Retrieval </a>&gt;&gt; Send Email to Users

]);


$helpb = acs::quick_help("Variables Available For Use In This Email ",qq[
</strong>You may use the variables (words) as listed below inside the email message. It
will be replaced by the for examples the names and details of the users you are mailing.
The %%extrafieldX%% variables will be replaced by the extra field data for user accounts.
For more on this see the Powerseek documentation. </p>


<p><strong>%%username%% </strong><br>
This will be replaced by the user name of the user account. </p>

<p><strong>%%password%% <br>
</strong>This will be replaced by the password of the user account. </p>

<p><strong>%%name%% <br>
</strong>This will be replaced by the user's name. </p>

<p><strong>%%extrafield1%% </strong></p>

<p><strong>%%extrafield2%% </strong></p>

<p><strong>%%extrafield3%% </strong></p>

<p><strong>%%extrafield4%% </strong></p>

<p><strong>%%extrafield5%% </strong></p>

<p><strong>%%extrafield6%% </strong></p>

<p><strong>%%extrafield7%% </strong></p>

<p><strong>%%extrafield8%% </strong></p>

<p><strong>%%extrafield9%% </strong></p>

<p><strong>%%extrafield10%% </strong></p>


]); 


 


print qq[

<html>
<head>
<title>PowerSeek</title>
</head>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">  
<body>

$hbox1



<form method="POST" action="$admin_url/admin63.cgi">
  <table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#C0C0C0">
    <tr>
      <td colspan="2" background="$web_url/bar6.gif" class="normaltext"><strong>Email Message: </strong></td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext">From Email Address: </td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="from_email" size="60"
      value="$from_email1" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext">From Name: </td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="from_name" size="60"
      value="$from_name1" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext">Subject: </td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="subject" size="60"
      value="$subject1" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext">Message: 
      <p><textarea rows="18" name="message" cols="63" style="width:100%">$message1</textarea> </td>
    </tr>
    <tr>
      <td width="20%" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="checkbox" name="subscribed_only" value="Y"
      $subschecked> Only send this email to users that has the chosen to subscribe to your
      newsletter. This option is available when users register an account or choose to edit
      their account details. </td>
    </tr>
    <tr>
      <td width="20%" bgcolor="#FFFFFF" class="normaltext">Number of emails to send at a time: </td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="emailnr" size="11"
      value="$emailnr1"> <br>
      Only a certain amount of email messages will be sent at a time not to overload your mail
      server. </td>
    </tr>
    <tr>
      <td width="20%" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="submit" value="   Send   " name="sendbut">
      <input type="hidden" name="fct" value="domailing"></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
  <table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#C0C0C0">
    <tr>
      <td colspan="2" background="$web_url/bar6.gif" class="normaltext"><strong>Send a Test Email </strong></td>
    </tr>
    <tr>
      <td colspan="2" bgcolor="#FFFFFF" class="normaltext">You can send the email message above to the
      email address below. This enables you to see how the message you are going to send looks
      like before mailing link owners. </td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext">Send it to email address: </td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="test_email" size="60"> </td>
    </tr>
    <tr>
      <td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="80%" bgcolor="#FFFFFF" class="normaltext"><input type="submit" value="   Send Test Email    "
      name="testbut"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>


$helpb

</body>
</html>

];


}





sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

